﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TGC.RadioButtonUtil.TestForm
{
    public enum Crystal
    {
        Red,
        Green,
        Blue
    }

    public enum Magic
    {
        Ice,
        Earth,
        Fire
    }

    public enum Class
    {
        Paladin,
        Magician
    }

    public class CharacterDescriptor
    {
        private Crystal crystal = Crystal.Red;
        private Magic magic = Magic.Earth;
        private Class characterClass = Class.Paladin;
        private int skill = 2;
        private bool isOutsider = false;
        private bool useSkillStones = false;

        public Crystal Crystal
        {
            get { return crystal; }
            set { crystal = value; }
        }

        public Magic Magic
        {
            get { return magic; }
            set { magic = value; }
        }

        public Class Class
        {
            get { return characterClass; }
            set { characterClass = value; }
        }

        public int Skill
        {
            get { return skill; }
            
            set
            {
                if (skill < 1 || skill > 3)
                    throw new ArgumentOutOfRangeException();
                else
                    skill = value;
            }
        }

        public bool IsOutsider
        {
            get { return isOutsider; }
            set { isOutsider = value; }
        }

        public bool UseSkillStones
        {
            get { return useSkillStones; }
            set { useSkillStones = value; }
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();

            sb.Append("Crystal: ");
            sb.AppendLine(crystal.ToString());

            sb.Append("Magic: ");
            sb.AppendLine(magic.ToString());

            sb.Append("Class: ");
            sb.Append(characterClass.ToString());

            if (isOutsider)
                sb.AppendLine(" (outsider)");
            else
                sb.AppendLine();

            sb.Append("Starting skill level: ");
            sb.Append(skill);
            sb.Append(" ( ==> initial strength: ");
            sb.Append(4 - skill);
            sb.AppendLine(")");

            sb.Append("Skill stones allowed: ");
            sb.AppendLine(useSkillStones.ToString());

            return sb.ToString();
        }
    }

}
